/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#include "ErrorHandler.h"


void CErrorHandler::Error(DWORD wParam, DWORD lParam)
{
    switch(wParam)
    {
        case MSG_ERROR:
            ::MessageBox(hWnd, (LPTSTR)lParam, _T("Error"), MB_OK + MB_ICONSTOP);
            break;
        case SYS_ERROR:
            SysError(lParam);
            break;
        case NET_ERROR:
            NetError(lParam);
            break;
    }
}

void CErrorHandler::SysError(DWORD dwError)
{
    if(dwError)
    {
        // get message
        DWORD count = ::FormatMessage(
            FORMAT_MESSAGE_FROM_SYSTEM,
            NULL,
            dwError,
            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
            Text,
            MAX_ERROR_TEXT_LEN,
            NULL);
        if(count == 0)
        {
            ::MessageBox(hWnd, _T("Unknown error."), _T("Error"), MB_OK + MB_ICONSTOP);
        }
        else
        {
            Text[count - 2] = 0;
            ::MessageBox(hWnd, Text, _T("Error"), MB_OK + MB_ICONSTOP);
        }
    }
}

void CErrorHandler::NetError(DWORD dwError)
{
    if(dwError)
    {
        // get message
        HANDLE hModule = ::GetModuleHandle(_T("wininet.dll"));
        DWORD count = ::FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM |
            FORMAT_MESSAGE_FROM_HMODULE,
            (LPCVOID)hModule,
            dwError,
            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
            Text,
            MAX_ERROR_TEXT_LEN,
            NULL);
        if(count == 0)
        {
            ::MessageBox(hWnd, _T("Unknown error."), _T("Error"), MB_OK + MB_ICONSTOP);
        }
        else
        {
            Text[count - 2] = 0;
            ::MessageBox(hWnd, Text, _T("Error"), MB_OK + MB_ICONSTOP);
        }
    }
}


