/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#include "AudioDecoder.h"

// ctor
CAudioDecoder::CAudioDecoder()
{
    // init
    ctx = NULL;
    codec = NULL;
    // prepare
    __avcodec_init();
    __avcodec_register_all();
}
//---------------------------------------------------------------------------
// dtor
CAudioDecoder::~CAudioDecoder()
{
}
//---------------------------------------------------------------------------
// video
int CAudioDecoder::open(GLOBAL_CONTEXT &oa_ctx)
{
    codec = (AVCodec *)__avcodec_find_decoder(CODEC_ID_MPEG4AAC);
    if(!codec)
    {
        return 0;
    }

    ctx = (AVCodecContext *)__avcodec_alloc_context();
    if(!ctx)
    {
        return 0;
    }

    // initialize context
    ctx->bit_rate = oa_ctx.abitrate;
    ctx->sample_rate = oa_ctx.wfx2->nSamplesPerSec;
    ctx->channels = oa_ctx.wfx2->nChannels;
    ctx->sample_fmt = SAMPLE_FMT_S16;

    return __avcodec_open(ctx, codec);
}

//---------------------------------------------------------------------------
int CAudioDecoder::decode(short *out, int *out_size, uint8_t *inp, int inp_size)
{
    return __avcodec_decode_audio(ctx, out, out_size, inp, inp_size);
}
//---------------------------------------------------------------------------
void CAudioDecoder::close()
{
    if(ctx != NULL)
    {
        __avcodec_close(ctx);
        __av_free(ctx);
        ctx = NULL;
    }
}
//---------------------------------------------------------------------------

