/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#include "AudioEncoder.h"

//---------------------------------------------------------------------------
// ctor
CAudioEncoder::CAudioEncoder()
{
    // init
    ctx = NULL;
    codec = NULL;
    // prepare
    __avcodec_init();
    __avcodec_register_all();
}
//---------------------------------------------------------------------------
// dtor
CAudioEncoder::~CAudioEncoder()
{
}
//---------------------------------------------------------------------------
// audio
int CAudioEncoder::open(GLOBAL_CONTEXT &cntx)
{
    codec = (AVCodec *)__avcodec_find_encoder(CODEC_ID_MPEG4AAC);
    if(!codec)
    {
        return 0;
    }

    ctx = (AVCodecContext *)__avcodec_alloc_context();
    if(!ctx)
    {
        return 0;
    }

    // initialize context
    ctx->bit_rate = cntx.abitrate;
    ctx->sample_rate = cntx.wfx->nSamplesPerSec;
    ctx->channels = cntx.wfx->nChannels;
    ctx->sample_fmt = SAMPLE_FMT_S16;

    if(__avcodec_open(ctx, codec) < 0)
    {
        return 0;
    }

    return ctx->frame_size;
}
//---------------------------------------------------------------------------
int CAudioEncoder::encode(uint8_t *out, int out_size, short *inp)
{
    return __avcodec_encode_audio(ctx, out, out_size, inp);
}
//---------------------------------------------------------------------------
void CAudioEncoder::close()
{
    if(ctx != NULL)
    {
        __avcodec_close(ctx);
        __av_free(ctx);
        ctx = NULL;
    }
}
//---------------------------------------------------------------------------


