/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#ifndef VIDEOENCODERH
#define VIDEOENCODERH

#include "context.h"
#include "avcodec.h"
#include "libavutil.h"
#include "libavcodec.h"

#ifdef INT_MODE
#define Y(r, g, b)((299 * r + 587 * g + 114 * b) / 1000)
#define U(b, y)((b - y) * 565 / 1000 + 128)
#define V(r, y)((r - y) * 713 / 1000 + 128)
#else
#define Y(r, g, b)(0.299 * r + 0.587 * g + 0.114 * b)
#define U(b, y)((b - y) * 0.565 + 128)
#define V(r, y)((r - y) * 0.713 + 128)
#endif

//---------------------------------------------------------------------------
class CVideoEncoder : public CAvUtil, CAvCodec
{
    AVCodec *codec;
    AVCodecContext *ctx;
    AVFrame *pict;
    AVPicture rgbPict;
    void RGB2I420P(RGBTRIPLE *rgb, uint8_t flip);

public:
    CVideoEncoder();
    virtual ~CVideoEncoder();
    // video
    int open(GLOBAL_CONTEXT &p_cntx);    // initialize
    int encode(RGBTRIPLE *inp, uint8_t *out, int inp_size, int *key_frame);
    void close();
};
//---------------------------------------------------------------------------

#endif
