/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#include "libavcodec.h"

// ctor
CAvCodec::CAvCodec()
{
    // load library
    hDll = ::LoadLibrary(_T("avcodec.dll"));
    if(hDll == NULL)
    {
        ::MessageBox(NULL, _T("Cannot load library avcodec.dll"), _T("Error"), MB_OK);
        exit(0);
    }
    // get functions
    __avcodec_init = (lpfn_avcodec_init *)::GetProcAddress(hDll, "avcodec_init");
    __avcodec_register_all = (lpfn_avcodec_register_all *)::GetProcAddress(hDll, "avcodec_register_all");
    __avcodec_find_encoder = (lpfn_avcodec_find_encoder *)::GetProcAddress(hDll, "avcodec_find_encoder");
    __avcodec_find_decoder = (lpfn_avcodec_find_decoder *)::GetProcAddress(hDll, "avcodec_find_decoder");
    __avcodec_alloc_context = (lpfn_avcodec_alloc_context *)::GetProcAddress(hDll, "avcodec_alloc_context");
    __avcodec_alloc_frame = (lpfn_avcodec_alloc_frame *)::GetProcAddress(hDll, "avcodec_alloc_frame");
    __avcodec_open = (lpfn_avcodec_open *)::GetProcAddress(hDll, "avcodec_open");
    __avcodec_close = (lpfn_avcodec_close *)::GetProcAddress(hDll, "avcodec_close");
    __avcodec_encode_audio = (lpfn_avcodec_encode_audio *)::GetProcAddress(hDll, "avcodec_encode_audio");
    __avcodec_encode_video = (lpfn_avcodec_encode_video *)::GetProcAddress(hDll, "avcodec_encode_video");
    __avcodec_decode_audio = (lpfn_avcodec_decode_audio *)::GetProcAddress(hDll, "avcodec_decode_audio");
    __avcodec_decode_video = (lpfn_avcodec_decode_video *)::GetProcAddress(hDll, "avcodec_decode_video");
}

// dtor
CAvCodec::~CAvCodec()
{
    // free library
    if(hDll)
    {
        ::FreeLibrary(hDll);
        hDll = NULL;
    }
}



