/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#ifndef LIBAVCODECH
#define LIBAVCODECH

#include <windows.h>
#include <tchar.h>

//---------------------------------------------------------------------------
typedef void (lpfn_avcodec_init)();
typedef void (lpfn_avcodec_register_all)();
typedef void* (lpfn_avcodec_find_encoder)(int);
typedef void* (lpfn_avcodec_find_decoder)(int);
typedef void* (lpfn_avcodec_alloc_context)();
typedef void* (lpfn_avcodec_alloc_frame)();
typedef int (lpfn_avcodec_open)(void*, void*);
typedef void (lpfn_avcodec_close)(void*);
typedef int (lpfn_avcodec_encode_audio)(void*, unsigned char*, int, const short*);
typedef int (lpfn_avcodec_encode_video)(void*, unsigned char*, int, const void*);
typedef int (lpfn_avcodec_decode_audio)(void*, short*, int*, const unsigned char*, int);
typedef int (lpfn_avcodec_decode_video)(void*, void*, int*, const unsigned char*, int);

//---------------------------------------------------------------------------

class CAvCodec
{
    HINSTANCE hDll;
public:
    CAvCodec();
    virtual ~CAvCodec();
    // functions
    lpfn_avcodec_init *__avcodec_init;
    lpfn_avcodec_register_all *__avcodec_register_all;
    lpfn_avcodec_find_encoder *__avcodec_find_encoder;
    lpfn_avcodec_find_decoder *__avcodec_find_decoder;
    lpfn_avcodec_alloc_context *__avcodec_alloc_context;
    lpfn_avcodec_alloc_frame *__avcodec_alloc_frame;
    lpfn_avcodec_open *__avcodec_open;
    lpfn_avcodec_close *__avcodec_close;
    lpfn_avcodec_encode_audio *__avcodec_encode_audio;
    lpfn_avcodec_encode_video *__avcodec_encode_video;
    lpfn_avcodec_decode_audio *__avcodec_decode_audio;
    lpfn_avcodec_decode_video *__avcodec_decode_video;
};

#endif
