/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/

#ifndef CONTEXTH
#define CONTEXTH

#include <windows.h>
#include <stdint.h>
#include <tchar.h>
#define ONESECOND100NANO 10000000ULL

#define ID_VIDEO 10
#define ID_AUDIO 20
#define MAGIC 0x5A5A5A
#define CIGAM 0xA5A5A5

class CLogo;
class CNetwork;
class CCallback;
class CErrorHandler;
class CAudioRenderer;
class CVideoRenderer;

typedef struct
{
    int ok;
    // network
    char host[MAX_PATH];
    int port;
    int connected;
    // video and audio
    int width;
    int height;
    int rate;
    int key_rate;
    int quality;
    int vbitrate;
    int abitrate;
    LPWAVEFORMATEX wfx;
    int frame_size;
    CLogo *logo;
    CNetwork *net;
    // direct show
    int preview;
    CCallback *v_call;
    CCallback *a_call;
    wchar_t video[MAX_PATH];
    wchar_t audio[MAX_PATH];
    int is_video;
    int is_audio;
    HWND hWndPrev;
    HWND *hWndRend;
    int x, y, dx, dy;
    int is_dsvideo;
    int is_dsaudio;
    CErrorHandler *err;
    int master;
    // h264
    int acodec_id;
    int vcodec_id;
    void *adsi;
    int adsi_size;
    void *vdsi;
    int vdsi_size;
    // DV
    int pal_ntsc;
    int dv_res;
    int half_rate;
    // VUMETRU
    HWND hWndWu;
    int sound;
    int cli;
    LPWAVEFORMATEX wfx2;
    CAudioRenderer *audio_rend;
    CVideoRenderer *video_rend;
    int tag;
    int ch_out;
    int ch_inp;
    int on_air;
} GLOBAL_CONTEXT;

struct TCP_HEADER
{
    uint32_t ch:8;
    uint32_t magic:24;
    uint32_t payload:7;
    uint32_t key:1;
    uint32_t size:24;
    uint32_t w:16;
    uint32_t h:16;
};

#endif