/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#include "Buffer.h"

//---------------------------------------------------------------------------
CBuffer::CBuffer()
{
    pos = 0;
    buff = NULL;
}
//---------------------------------------------------------------------------
CBuffer::~CBuffer()
{
    if(buff)
    {
        free(buff);
        buff = NULL;
    }
}
//---------------------------------------------------------------------------
int CBuffer::put(unsigned char *src, unsigned size)
{
    unsigned char *tmp = (unsigned char *)realloc(buff, pos + size);
    if(tmp == NULL)
    {
        return 0;
    }
    buff = tmp;
    memcpy(buff + pos, src, size);
    pos += size;
    return 1;
}
//---------------------------------------------------------------------------
int CBuffer::get(unsigned char *dst, unsigned size)
{
    if(size > pos)
    {
        return 0;
    }
    memcpy(dst, buff, size);
    pos -= size;
    if(pos > 0)
    {
        memcpy(buff, buff + size, pos);
    }
    return 1;
}
//---------------------------------------------------------------------------

