/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#include "Device.h"

CDevice::CDevice()
{
}

CDevice::~CDevice()
{
}

BOOL CDevice::GetSources(HWND hWnd, int kind)
{
    HRESULT hr;
    // Create the System Device Enumerator.
    ICreateDevEnum *pSysDevEnum;
    hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
        IID_ICreateDevEnum, (void **)&pSysDevEnum);
    if(hr != S_OK)
    {
        return FALSE;
    }
    // Obtain a class enumerator for the video compressor category.
    IEnumMoniker *pEnumCat;
    hr = pSysDevEnum->CreateClassEnumerator(
        (kind == 0) ? CLSID_VideoInputDeviceCategory : CLSID_AudioInputDeviceCategory, &pEnumCat, 0);
    if(hr != S_OK)
    {
        return FALSE;
    }
    // Enumerate the monikers.
    ULONG cFetched;
    IMoniker *pMoniker;
    VARIANT varName;
    while(pEnumCat->Next(1, &pMoniker, &cFetched) == S_OK)
    {
        IPropertyBag *pPropBag;
        if(pMoniker->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pPropBag) == S_OK)
        {
            // To retrieve the friendly name of the filter, do the following:
            VariantInit(&varName);
            hr = pPropBag->Read(L"FriendlyName", &varName, 0);
            if(hWnd && (hr == S_OK))
            {
                ::SendMessage(hWnd, CB_ADDSTRING, 0, (LONG)varName.bstrVal);
            }
            VariantClear(&varName);
            hr = pPropBag->Release();
        }
        hr = pMoniker->Release();
    }
    // clean up
    hr = pEnumCat->Release();
    hr = pSysDevEnum->Release();
    return TRUE;
}


