/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#ifndef NETWORKH
#define NETWORKH

#include "context.h"
#include "Monitor.h"
#include "PushSink.h"
#include "VideoEncoder.h"
#include "AudioEncoder.h"

class CNetwork : public CMonitor
{
    GLOBAL_CONTEXT *cntx;
    CPushSink *sink;
    CVideoEncoder vid;
    CAudioEncoder aud;
    void EncodeVideo(uint8_t *buffer, uint32_t size);
    void EncodeAudio(uint8_t *buffer, uint32_t size);
    uint32_t frame_size;
    uint32_t chunks;
    uint32_t chunk_size;
public:
    CNetwork(GLOBAL_CONTEXT &p_cntx);
    virtual ~CNetwork();
    // callback's
    virtual void OnVideo(uint8_t *buffer, uint32_t size);
    virtual void OnAudio(uint8_t *buffer, uint32_t size);
    virtual void ReOpenVideo();
    virtual void ReOpenAudio();
};

#endif;
