/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#ifndef PUSHSINKH
#define PUSHSINKH

#include <winsock2.h>
#include <stdint.h>
#include "Context.h"
#include "ErrorHandler.h"
#include "DownStream.h"

//---------------------------------------------------------------------------

class CPushSink
{
    // host
    GLOBAL_CONTEXT *cntx;
    SOCKET cli;
    sockaddr_in ss;
    TCP_HEADER hdr_aud, hdr_vid;
    // utils
    void Error(DWORD wParam, DWORD lParam);
    unsigned long host_addr(LPCSTR host);
    CDownStream *down;

public:
    CPushSink(GLOBAL_CONTEXT &p_ctx);
    virtual ~CPushSink();
    virtual int SendVideo(uint8_t *buffer, uint32_t size, uint32_t key);
    virtual int SendAudio(uint8_t *buffer, uint32_t size);
    virtual void OpenSink();
    virtual void CloseSink();
};

//---------------------------------------------------------------------------

#endif


