/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#include "Thread.h"

//-----------------------------------------------------------------------------
DWORD WINAPI CThread::ThreadProc(LPVOID lpThread)
{
    ((CThread *)lpThread)->Run();
    return 0;
}
//-----------------------------------------------------------------------------
CThread::CThread()
{
    // ctor
    hThread = NULL;
    hEvent = NULL;
    ThreadId = 0;
}
//-----------------------------------------------------------------------------
CThread::~CThread()
{
    // dtor
    if(hThread)
    {
        ::CloseHandle(hThread);
        hThread = NULL;
    }
    if(hEvent)
    {
        ::CloseHandle(hEvent);
        hEvent = NULL;
    }
}
//-----------------------------------------------------------------------------
BOOL CThread::StartThread(int Priority)
{
    // event 
    hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL);
    if(!hEvent)
    {
        return FALSE;
    }
    ::ResetEvent(hEvent);
    // spawn a new thread
    hThread = ::CreateThread(NULL, 0, ThreadProc, this,
        CREATE_SUSPENDED, &ThreadId);
    if(!hThread)
    {
        return FALSE;
    }
    // set priority and run
    ::SetThreadPriority(hThread, Priority);
    ::ResumeThread(hThread);
    return TRUE;
}
//-----------------------------------------------------------------------------
void CThread::StopThread()
{
    ::SetEvent(hEvent);
}
//-----------------------------------------------------------------------------
void CThread::WaitFor(DWORD dwMilliseconds)
{
    ::WaitForSingleObject(hThread, dwMilliseconds);
}
//-----------------------------------------------------------------------------
BOOL CThread::Terminated(DWORD dwMilliseconds)
{
    return (::WaitForSingleObject(hEvent, dwMilliseconds) == WAIT_OBJECT_0);
}
//-----------------------------------------------------------------------------

