/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#ifndef AudioRendererH
#define AudioRendererH

#define RINGSIZE 32
#include "AudioDecoder.h"

class CAudioRenderer
{
    GLOBAL_CONTEXT *actx;
    // audio renderer
    HWAVEOUT hwo;
    WAVEHDR whdr[RINGSIZE];
    CAudioDecoder dec;
    unsigned char out[AVCODEC_MAX_AUDIO_FRAME_SIZE];
    int Decode(unsigned char *tmp_out, unsigned char *tmp_inp, int inp_size);
    int ii;
public:
    CAudioRenderer();
    virtual ~CAudioRenderer();
    void Open(GLOBAL_CONTEXT &ctx);
    void Close();
    int Play(unsigned char *data, int size);
    DWORD GetVolume();
    void SetVolume(DWORD Volume);

};

#endif
