/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
#include "VideoRenderer.h"

//---------------------------------------------------------------------------
CVideoRenderer::CVideoRenderer()
{
    bits = NULL;
}
//---------------------------------------------------------------------------
CVideoRenderer::~CVideoRenderer()
{
}
//---------------------------------------------------------------------------
void CVideoRenderer::Open(GLOBAL_CONTEXT &oa_ctx)
{
    cntx = &oa_ctx;
	memcpy(hWnd, cntx->hWndRend, CHANNELS * sizeof(HWND));

    memset(&bi, 0, sizeof(bi));
    bi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    bi.bmiHeader.biPlanes = 1;
    bi.bmiHeader.biBitCount = 0;
    bi.bmiHeader.biCompression = mmioFOURCC('I','4','2','0');
    bi.bmiHeader.biWidth = oa_ctx.width;
    bi.bmiHeader.biHeight = oa_ctx.height;
    bi.bmiHeader.biSizeImage = oa_ctx.width * oa_ctx.height * 3 / 2;

    bits = (BYTE *)malloc(bi.bmiHeader.biSizeImage);

    for(int i = 0;i < CHANNELS;i++)
    {
        hdc[i] = ::GetDC(hWnd[i]);
        hdraw[i] = ::DrawDibOpen();
        ::DrawDibBegin(hdraw[i], hdc[i], cntx->x, cntx->y,
            &bi.bmiHeader, WIDTH, HEIGHT, //oa_ctx.width, oa_ctx.height,
            DDF_HALFTONE);
        dec[i].open(oa_ctx);
    }
}
//---------------------------------------------------------------------------
void CVideoRenderer::Close()
{
    for(int i = 0;i < CHANNELS;i++)
    {
        ::DrawDibEnd(hdraw[i]);
        ::DrawDibClose(hdraw[i]);
        ::ReleaseDC(hWnd[i], hdc[i]);
        dec[i].close();
    }
    // free
    if(bits)
    {
        free(bits);
        bits = NULL;
    }
}
//---------------------------------------------------------------------------
void CVideoRenderer::DrawFrame(unsigned char *buffer, int size, int key, int cam)
{
    // draw the frame
    if(bits && dec[cam - 1].decode(buffer, size, bits, key))
    {
        ::DrawDibDraw(hdraw[cam - 1], hdc[cam - 1],
            1, 1, WIDTH, HEIGHT, &bi.bmiHeader, bits,
            0, 0, bi.bmiHeader.biWidth, bi.bmiHeader.biHeight,
            (key) ? DDF_JUSTDRAWIT : DDF_SAME_HDC);
    }
}
//---------------------------------------------------------------------------

