/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/

#include "ErrorHandler.h"

TCHAR CErrorHandler::Text[MAX_ERROR_TEXT_LEN];

void CErrorHandler::Error(DWORD wParam, DWORD lParam)
{
    switch(wParam)
    {
        case MSG_ERROR:
            _tcscpy(Text, (LPTSTR)lParam);
            cout << Text << endl;
            break;
        case SYS_ERROR:
            if(lParam)
            {
                // get message
                DWORD count = ::FormatMessage(
                    FORMAT_MESSAGE_FROM_SYSTEM,
                    NULL,
                    lParam,
                    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                    Text,
                    MAX_ERROR_TEXT_LEN,
                    NULL);
                if(count == 0)
                {
                    _tcscpy(Text, _T("Unknown error."));
                }
                cout << Text << endl;
            }
            break;
    }
}


