/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/

#include <iostream.>
using namespace std;

#include "gateway.h"

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused


int main(int argc, char* argv[])
{
    char ch;
    SRV_CONTEXT cntx;
    WSADATA wsaData;
    int echo = 0;

    ::WSAStartup(MAKEWORD(2, 0), &wsaData);

    cout << "Together Server - Copyright (C) 2010 Gmax" << endl;

    for(int i = 1;i < argc;i++)
    {
        echo = (strcmp(argv[i], "/echo") == 0) ? 1 : 0;
    }

    // create an instance of server
    memset(&cntx, 0, sizeof(cntx));
    cntx.echo = echo;
    cntx.port = 1958;
    cntx.gate = new CGateway(&cntx);
    if(cntx.gate)
    {
        // start the server
        cntx.gate->StartThread();
        // wait for CTRL+C
        cout << "Press CTRL+C to stop..." << endl;
        cin >> ch;
        // stop the server
        cntx.gate->StopThread();
        cntx.gate->ShutDown();
        cntx.gate->WaitFor();
        delete cntx.gate;
    }

    ::WSACleanup();
    return 0;
}
//---------------------------------------------------------------------------
