/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/

#ifndef THREADH
#define THREADH

#include <windows.h>

class CThread
{
protected:
    DWORD ThreadId;
    HANDLE hThread;
    HANDLE hEvent;
    static DWORD WINAPI ThreadProc(LPVOID lpThread);
    BOOL Terminated(DWORD dwMilliseconds = 0);
public:
    CThread();
    virtual ~CThread();
    BOOL StartThread(int Priority = THREAD_PRIORITY_NORMAL);
    void StopThread();
    void WaitFor(DWORD dwMilliseconds = 30000);
    virtual void Run() = 0;
};

#endif
