/****************************************************************************
* Together - Simple Videoconference System
* Copyright (C) 2010 Marius Gligor info@gmax.ws
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/

#ifndef CONTEXTH
#define CONTEXTH

#include <windows.h>
#include <tchar.h>
#include <errors.h>
#include <stdint.h>

class CGateway;

#define MAGIC 0x5A5A5A
#define CIGAM 0xA5A5A5

typedef struct
{
    int ok;
    int conns;
    CGateway *gate;
    int cli;
    int echo;
    int port;
} SRV_CONTEXT;

struct TCP_HEADER
{
    uint32_t ch:8;
    uint32_t magic:24;
    uint32_t payload:7;
    uint32_t key:1;
    uint32_t size:24;
    uint32_t w:16;
    uint32_t h:16;
};

#endif
